=== modified file 'src/com/goldencode/p2j/persist/BufferManager.java'
--- old/src/com/goldencode/p2j/persist/BufferManager.java	2022-07-07 16:14:44 +0000
+++ new/src/com/goldencode/p2j/persist/BufferManager.java	2022-09-06 18:22:04 +0000
@@ -1648,45 +1373,7 @@
     */
    public boolean isTransaction()
    {
-      return transactionDepth >= 0;
-   }
-   
-   /**
-    * Check whether the block at the specified block depth is within an application-level
-    * transaction.
-    * 
-    * @param   level
-    *          Zero-based block depth (counting from the outermost scope).
-    * 
-    * @return  {@code true} if we are in a transaction, else {@code false}.
-    */
-   public boolean isTransactionAt(int level)
-   {
-      return transactionDepth >= 0 && transactionDepth <= level;
-   }
-   
-   /**
-    * Check whether the current block marks (and is within) the boundary of an application-level
-    * full transaction.
-    * 
-    * @return  {@code true} if we are at (and within) a full transaction boundary, else {@code
-    *          false}.
-    */
-   public boolean isFullTransaction()
-   {
-      return transactionDepth >= 0 && getOpenBufferScopes() - 1 == transactionDepth;
-   }
-   
-   /**
-    * Get the zero-based block depth (counting from the outermost scope) at which the current,
-    * full, application-level transaction (if any) began.
-    * 
-    * @return  Zero-based block depth of current, full transaction, or -1 if we are not currently
-    *          within a transaction.
-    */
-   public int getFullTransactionBlock()
-   {
-      return transactionDepth;
+      return txWrapperHelper.isTransaction();
    }
    
    /**
@@ -1699,7 +1386,17 @@
     */
    public long getScopeTransitions()
    {
-      return scopeTransitions;
+      return txWrapperHelper.getScopeTransitions();
+   }
+   
+   /**
+    * Get the open buffers from the current scope.
+    * 
+    * @return   See above.
+    */
+   Collection<RecordBuffer> getOpenBuffers()
+   {
+      return openBuffers.scopes() == 0 ? Collections.EMPTY_LIST : openBuffers.sublistAtScope(0);
    }
    
    /**
@@ -1709,7 +1406,7 @@
     */
    long getTransactionCount()
    {
-      return transactionCount;
+      return txWrapperHelper.getTransactionCount();
    }
    
    /**
@@ -1752,6 +1449,7 @@
          throw new UnsupportedOperationException(
            "A buffer can't be bound to more than one table in the same program!");
       }
+
       dstBuffers.add(dstBuf);
       
       bindBuffer(dstBuf, srcBuf);
@@ -1870,37 +1568,6 @@
    }
    
    /**
-    * Register an undoable which is responsible for setting the buffer's 
-    * proper current record after all reversibles are processed.
-    * 
-    * @param   buffer
-    *          Record buffer for which a change is being tracked for undo
-    *          purposes.  It is assumed the buffer has been initialized.
-    * @param   undoTarget
-    *          The undoable responsible with setting the buffer back to its
-    *          proper record.
-    */
-   void registerBufferUndoable(RecordBuffer buffer, Undoable undoTarget)
-   {
-      Map<BufferType, UndoData> dict = undoData.getDictionaryAtScope(0, true);
-      
-      RecordBuffer master = buffer.getMasterBuffer();
-      BufferType key = master.getBufferType();
-      
-      if (dict != null)
-      {
-         UndoData ud = dict.get(key);
-         if (ud == null)
-         {
-            ud = new UndoData();
-            dict.put(key, ud);
-         }
-         
-         ud.bufferUndoable = undoTarget.deepCopy();
-      }
-   }
-   
-   /**
     * Register a newly defined record buffer in the current scope.  Buffers are deregistered
     * implicitly when the scope in which they were registered ends.
     *
@@ -1937,6 +1604,8 @@
     */
    void registerPending(Class<?> def, RecordBuffer buffer)
    {
+      registerPendingScopeable(this);
+      
       pendingBuffers.add(buffer);
       
       registerPendingBufferClass(buffer, def);
@@ -1983,7 +1652,6 @@
       
       int[] allBufferScopes = buffer.getAllBuferScopes();
       int[] byLegacyNameScopes = buffer.getByLegacyNameScopes();
-      int[] loadedBuffersScopes = buffer.getLoadedBuffersScope();
       int[] openBuffersScopes = buffer.getOpenBuffersScope();
       
       int scopeSize = allBuffers.size();
@@ -2029,22 +1697,7 @@
       // remove from global scope always
       // openBuffers.removeFrom(openScopes - 1, buffer);
       
-      int loadedScopes = loadedBuffers.size();
-      for (int scope : loadedBuffersScopes)
-      {
-         int depth = loadedScopes - scope;
-         Map<RecordBuffer, Boolean> loaded = loadedBuffers.getDictionaryAtScope(depth, false);
-         if (loaded != null)
-         {
-            loaded.remove(buffer);
-         }
-      }
-      // remove from global scope always
-      Map<RecordBuffer, Boolean> loaded = loadedBuffers.getDictionaryAtScope(-1, false);
-      if (loaded != null)
-      {
-         loaded.remove(buffer);
-      }
+      txWrapperHelper.deregisterDynamicBuffer(buffer);
       
       if (referent != null)
       {
@@ -2053,7 +1706,6 @@
          {
             procScope.allBuffers.remove(key);
             byLegacy.accept(procScope.byLegacyName);
-            procScope.loadedBuffers.remove(buffer);
             procScope.openBuffers.remove(buffer);
          }
       }
@@ -2082,6 +1734,8 @@
     */
    void startBatchAssignMode(boolean internal)
    {
+      registerScopeable(this);
+      
       int currentScope = getOpenBufferScopes();
       BatchModeData bmd = batchModeStack.peek();
       
@@ -2382,20 +2036,6 @@
    }
    
    /**
-    * Remove all <code>Reversible</code> objects associated with the given buffer from their
-    * respective scoped dictionaries.
-    * 
-    * @param   buffer
-    *          Buffer associated with the <code>Reversible</code>s to be removed.
-    */
-   void removeAllReversibles(TemporaryBuffer buffer)
-   {
-      // delete entries from current and parent scopes
-      BufferType bufType = buffer.getMasterBuffer().getBufferType();
-      undoData.removeEntryThroughScope(bufType, 1);
-   }
-   
-   /**
     * Called by {@link RecordBuffer} when a new buffer scope is opened. It registers the open scope with the
     * buffer manager, so that the buffer can receive block scope start and stop notifications, and be
     * registered for commit/rollback/validate processing when a full transaction is begun.
@@ -2457,6 +2097,8 @@
     */
    void registerPendingStaticTempTable(StaticTempTable table, boolean global)
    {
+      registerPendingScopeable(this);
+
       pendingStaticTempTables.put(table, global);
    }
    
@@ -2658,6 +2300,8 @@
     */
    void openScopeAt(int openScopeDepth, RecordBuffer buffer)
    {
+      // TODO: this seems to be called only for 'openScopeDepth == 0'.
+
       if (buffer.isActive())
       {
          if (openScopeDepth == 0)
@@ -2759,11 +2403,7 @@
     */
    void maybeActivateTxWrapper(Database database)
    {
-      TxWrapper txw = inactiveTxWrappers.remove(database);
-      if (txw != null)
-      {
-         txw.activate();
-      }
+      txWrapperHelper.maybeActivateTxWrapper(database);
    }
    
    /**
@@ -2932,18 +2572,7 @@
     */
    void notifyRecordWasLoaded(RecordBuffer recordBuffer)
    {
-      if (recordBuffer.getCurrentRecord() != null && !recordBuffer.isDynamic())
-      {
-         pm.notifyStaticRecordWasLoaded(recordBuffer);
-      }
-      
-      if (recordBuffer.getCurrentRecord() == null || recordBuffer.isTemporary())
-      {
-         return;
-      }
-      
-      loadedBuffers.addEntry(false, recordBuffer, false);
-      recordBuffer.addLoadedBuffersScope(loadedBuffers.size());
+      txWrapperHelper.notifyRecordWasLoaded(recordBuffer);
    }
    
    /**
@@ -3035,41 +2664,6 @@
    }
    
    /**
-    * Create an inactive transaction wrapper for the given database. It will be activated the
-    * first time an open buffer scope is detected or when a new buffer scope is opened, at which
-    * time a database-level transaction will be opened.
-    * 
-    * @param   database
-    *          Database for which this transaction wrapper is created.
-    * 
-    * @return  Transaction wrapper object.
-    */
-   private TxWrapper createTxWrapper(Database database)
-   {
-      TxWrapper txw = new TxWrapper(database);
-      txWrapperMap.put(database, txw);
-      inactiveTxWrappers.put(database, txw);
-      
-      return txw;
-   }
-   
-   /**
-    * Compose a message suitable for logging.  Reports open buffer scopes and
-    * context information in addition to a custom message.
-    *
-    * @param   persistence
-    *          Persistence object which will provide context info.
-    * @param   text
-    *          Custom message text.
-    *
-    * @return  Composed message text.
-    */
-   private String message(Persistence persistence, String text)
-   {
-      return persistence.message("scope " + getOpenBufferScopes() + ": " + text);
-   }
-   
-   /**
     * Add the source buffers to the destination map.
     * 
     * @param    dst
@@ -3103,34 +2697,7 @@
     */
    private void trackDatabase(RecordBuffer buffer, boolean add)
    {
-      if (add)
-      {
-         Database database = buffer.getDatabase();
-         MutableInteger count = activeDatabases.get(database);
-         if (count == null)
-         {
-            activeDatabases.put(database, count = new MutableInteger(0));
-         }
-         count.set(count.get() + 1);
-      }
-      else if (buffer.isActive() && buffer.getOpenScopeCount() > 0)
-      {
-         Database database = buffer.getDatabase();
-         MutableInteger count = activeDatabases.get(database);
-         if (count == null)
-         {
-            throw new IllegalStateException("Tracking for " + database + " is unbalanced!");
-         }
-         
-         if (count.get() == 1)
-         {
-            activeDatabases.remove(database);
-         }
-         else
-         {
-            count.set(count.get() - 1);
-         }
-      }
+      txWrapperHelper.trackDatabase(buffer, add);
    }
    
    /**
@@ -3147,442 +2714,9 @@
     * @return  {@code true} if the block is considered &quot;important&quot; by the above criteria, else
     *          {@code false}.
     */
-   private boolean isImportantBlockTransition()
-   {
-      return !txHelper.isTransaction() ||
-             txHelper.currentTransactionLevel() != TransactionManager.NO_TRANSACTION;
-   }
-   
-   /**
-    * Storage mechanism for maps of reversible/undoable actions, keyed by
-    * primary key.  One instance of this class holds all such objects for a
-    * single buffer in a single scope.
-    */
-   private static class UndoData
-   {
-      /** Undoable which will set a no-undo buffer to its proper record after a rollback. */
-      Undoable bufferUndoable;
-   }
-   
-   /**
-    * An object which manages the "master" {@code Commitable} and {@code Finalizable} events of an
-    * application transaction. It creates a database transaction to correspond with the application
-    * transaction, and as it receives events from the {@code TransactionManager}, it delegates related
-    * responsibilities to various components of the persistence framework.
-    */
-   private class TxWrapper
-   implements Finalizable,
-              Commitable
-   {
-      /** Backing database */
-      private final Database database;
-      
-      /** Dirty share context */
-      private final DirtyShareContext dirtyContext;
-      
-      /** Savepoint manager (can be {@code null} */
-      private final SavepointManager savepointManager;
-      
-      /** Persistence context, for access to database session and transaction */
-      private Persistence.Context persistenceCtx;
-      
-      /** Roll back the transaction when block finishes, if not previously acted upon */
-      private boolean autoRollback = false;
-      
-      /** {@code true} for an initial transaction only until the first commit or rollback */
-      private boolean initialTx = false;
-      
-      /**
-       * The sole constructor.
-       *
-       * @param   database
-       *          The {@code Database} where the transaction takes place.
-       */
-      TxWrapper(Database database)
-      {
-         this.database = database;
-         // Because the BufferManager manages all record buffers within the current user context, we cannot
-         // separate the DIRTY-READ from the normal tables at this moment. Since this instance is only used
-         // for final cleanup, we acquire the context for the DIRTY-READ database so that context will be
-         // cleaned up correctly. The non-DIRTY-READ information will be ignored.
-         this.dirtyContext = DirtyShareFactory.getContextInstance(database);
-         this.savepointManager =
-            (DatabaseManager.TEMP_TABLE_DB.equals((database)) && DatabaseManager.FORCE_NO_UNDO_TEMP_TABLES)
-            ? null
-            : new SavepointManager();
-         
-         // register for master transaction commit/rollback
-         txHelper.registerTransactionCommit(this, true);
-         
-         // register for master transaction finish/iterate
-         txHelper.registerTransactionFinish(this, true);
-      }
-      
-      /**
-       * Implementation of {@code Finalizable} interface: provides a notification that the block whose scope
-       * in which the object is registered is about to iterate and attempt another pass.  This provides an
-       * opportunity to preserve state from the previous pass and make preparations for the coming pass.
-       */
-      @Override
-      public void iterate()
-      {
-         if (!isActive())
-         {
-            return;
-         }
-         
-         if (LOG.isLoggable(Level.FINE))
-         {
-            LOG.log(Level.FINE, message(persistenceCtx.getPersistence(), "master transaction iterate"));
-         }
-         
-         end();
-         begin();
-      }
-      
-      /**
-       * Implementation of {@code Finalizable} interface: provides a notification that the block whose scope
-       * in which the object is registered is about to retry the same iteration (all loop control data is
-       * unchanged). This provides an opportunity to clear or reset state from the previous pass.
-       */
-      @Override
-      public void retry()
-      {
-         if (!isActive())
-         {
-            return;
-         }
-         
-         if (LOG.isLoggable(Level.FINE))
-         {
-            LOG.log(Level.FINE,
-                    message(persistenceCtx.getPersistence(), "master transaction retry"));
-         }
-         
-         end();
-         begin();
-      }
-      
-      /**
-       * Implementation of {@code Finalizable} interface: Provides a notification that the scope in which the
-       * object is registered is ending and the object's reference may or may not be lost after this method
-       * is called. This provides a natural and standard mechanism to clean-up any resources that may need
-       * to be closed explicitly such as operating system files or sockets.
-       */
-      @Override
-      public void finished()
-      {
-         try
-         {
-            if (autoRollback)
-            {
-               if (isActive() && LOG.isLoggable(Level.FINE))
-               {
-                  LOG.log(Level.FINE,
-                          message(persistenceCtx.getPersistence(), "triggering auto-rollback"));
-               }
-               
-               rollback(true);
-            }
-         }
-         finally
-         {
-            if (isActive() && LOG.isLoggable(Level.FINE))
-            {
-               LOG.log(Level.FINE,
-                       message(persistenceCtx.getPersistence(), "master transaction finished"));
-            }
-            
-            txWrapperMap.remove(database);
-            
-            if (!isActive())
-            {
-               inactiveTxWrappers.remove(database);
-               
-               return;
-            }
-            
-            end();
-         }
-      }
-      
-      /**
-       * Implementation of {@code Finalizable} interface: provides a notification that the external program
-       * in which the object is registered is being deleted and the object's reference may be lost after this
-       * method is called.
-       */
-      @Override
-      public void deleted()
-      {
-         // no-op
-      }
-      
-      /**
-       * Implementation of {@code Commitable} interface: saves any temporary state to the persistent form or
-       * storage that is associated with this class.
-       *
-       * @param    transaction
-       *           {@code true} if this is a full transaction and {@code false} if this is only a
-       *           sub-transaction (a nested scope with transaction support).
-       */
-      @Override
-      public void commit(boolean transaction)
-      {
-         if (!isActive())
-         {
-            return;
-         }
-         
-         if (LOG.isLoggable(Level.FINE))
-         {
-            LOG.log(Level.FINE,
-                    message(persistenceCtx.getPersistence(), "master transaction commit"));
-         }
-         
-         try
-         {
-            initialTx = false;
-            autoRollback = false;
-            persistenceCtx.commit();
-         }
-         catch (PersistenceException exc)
-         {
-            if (LOG.isLoggable(Level.SEVERE))
-            {
-               LOG.log(Level.SEVERE,
-                       message(persistenceCtx.getPersistence(), "commit error"), exc);
-            }
-            
-            // No good way to recover from this.  Let it abend.
-            throw new RuntimeException(exc);
-         }
-         finally
-         {
-            // Reclaim any primary keys which had been waiting to be recycled,
-            // pending a commit.
-            if (DatabaseManager.TEMP_TABLE_DB.equals(database))
-            {
-               Commitable ctx = TemporaryBuffer.getContextCommitable();
-               ctx.commit(transaction);
-            }
-         }
-      }
-      
-      /**
-       * Implementation of {@code Commitable} interface: notifies that a rollback has just occurred (all state
-       * maintained through the {@link Undoable} interface has been already rolled back). This notification
-       * can be used to implement cleanup of any custom state that needs to be maintained in this case. It can
-       * also be used to implement a rollback that is completely independent of the {@code Undoable}
-       * (externally driven) interface.
-       *
-       * @param    transaction
-       *           {@code true} if this is a full transaction and {@code false} if this is only a
-       *           sub-transaction (a nested scope with transaction support).
-       */
-      @Override
-      public void rollback(boolean transaction)
-      {
-         if (!isActive())
-         {
-            return;
-         }
-         
-         if (LOG.isLoggable(Level.FINE))
-         {
-            LOG.log(Level.FINE,
-                    message(persistenceCtx.getPersistence(), "master transaction rollback"));
-         }
-         
-         boolean isTempDB = DatabaseManager.TEMP_TABLE_DB.equals(database);
-         
-         if (isTempDB && savepointManager == null)
-         {
-            // we force all temp-tables to be no-undo, so instead of rollback, do a 
-            // commit of the current transaction
-            commit(transaction);
-            
-            return;
-         }
-         
-         try
-         {
-            initialTx = false;
-            autoRollback = false;
-            persistenceCtx.rollback(false);
-         }
-         catch (PersistenceException exc)
-         {
-            if (LOG.isLoggable(Level.SEVERE))
-            {
-               LOG.log(Level.SEVERE,
-                       message(persistenceCtx.getPersistence(), "rollback error"), exc);
-            }
-            
-            // No good way to recover from this.  Let it abend.
-            throw new RuntimeException(exc);
-         }
-         
-         if (isTempDB)
-         {
-            // clear any primary keys which had been waiting to be recycled, pending a commit
-            Commitable ctx = TemporaryBuffer.getContextCommitable();
-            ctx.rollback(transaction);
-         }
-      }
-
-      /**
-       * Implementation of {@code Commitable} interface: Notifies that a block is about to be normally exited
-       * or normally iterated and that any deferred validation processing should be executed.
-       * <p>
-       * This particular implementation is a NOP.
-       * 
-       * @param   transaction
-       *          Ignored.
-       * @param   aggressiveFlush
-       *          Ignored.
-       */
-      @Override
-      public void validate(boolean transaction, boolean aggressiveFlush)
-      {
-         // no-op
-      }
-      
-      /**
-       * Registers the commitable and finalizable for savepoint manager, if any.
-       * 
-       * @param   fullTx
-       *          {@code true} if this is a full-transaction.
-       */
-      void registerSavepointHooks(boolean fullTx)
-      {
-         if (savepointManager != null)
-         {
-            savepointManager.registerBlockHooks(txHelper, fullTx);
-         }
-      }
-      
-      /**
-       * Activates the transaction. This entails starting a database-level transaction and activating a
-       * savepoint manager for that transaction.
-       */
-      void activate()
-      {
-         if (isActive())
-         {
-            return;
-         }
-         
-         Persistence persistence = PersistenceFactory.getInstance(database);
-         persistenceCtx = persistence.getContext();
-         
-         if (LOG.isLoggable(Level.FINE))
-         {
-            LOG.log(Level.FINE,
-                    message(persistenceCtx.getPersistence(),
-                            "registered for master transaction commit/finished"));
-            
-            persistenceCtx.enableTransactionTrace(true);
-         }
-         
-         begin();
-         initialTx = true;
-      }
-      
-      /**
-       * Checks whether this {@code TxWrapper} is active.
-       * 
-       * @return  {@code true} only if {@code TxWrapper} was activated.
-       */
-      boolean isActive()
-      {
-         return (persistenceCtx != null);
-      }
-      
-      /**
-       * Convert the current object to its string representation to be used during debugging.
-       * 
-       * @return  A short string representation of this object to be used while debugging.
-       */
-      @Override
-      public String toString()
-      {
-         return "TxWrapper{database=" + database + '}';
-      }
-      
-      /** Starts the actual transaction at persistence level. */
-      private void begin()
-      {
-         try
-         {
-            if (!persistenceCtx.beginTransaction(savepointManager) && !initialTx)
-            {
-               // We are here because we tried to begin a database level transaction and one is
-               // already open. This situation generally is invalid, except in an edge case
-               // where a new transaction is opened while in TM's iterate worker. This can happen
-               // if, for example, a new database is accessed during the execution of a trigger
-               // fired during iterate processing. The only case we have seen of this so far is
-               // due to a record being released during RB's iterate processing, which then fires
-               // a write trigger, which accesses a buffer in a separate database (e.g., for
-               // audit purposes) which did not previously have a transaction open. This in turn
-               // invokes this object's c'tor, which registers for master finish notification,
-               // but also opens a new transaction. We then get here a moment later during master
-               // finish processing. Commit has not yet been called, since commitable processing
-               // for that block already has occurred. The solution is to check the initialTx
-               // flag and simply ignore the fact that a new transaction could not be created if
-               // that flag is true. The flag will be set to false on the first commit or
-               // rollback.
-               Persistence persistence = persistenceCtx.getPersistence();
-               if (LOG.isLoggable(Level.FINE))
-               {
-                  Throwable beginTxTrace = persistence.getBeginTxTrace();
-                  if (beginTxTrace != null)
-                  {
-                     String msg = "Current transaction previously started at location...";
-                     LOG.log(Level.FINE, persistence.message(msg), beginTxTrace);
-                  }
-               }
-               
-               throw new IllegalStateException(
-                  message(persistence, "database transaction already active"));
-            }
-            
-            autoRollback = true;
-         }
-         catch (PersistenceException exc)
-         {
-            // TODO: proper error handling
-            throw new StopConditionException(exc);
-         }
-      }
-      
-      /** Shuts down the transaction at persistence level and performs key management. */
-      private void end()
-      {
-         // clear nursery
-         persistenceCtx.getNursery().transactionEnded();
-         
-         // clean up dirty shares for this transaction
-         if (dirtyContext != null)
-         {
-            dirtyContext.cleanup();
-         }
-         
-         // release or downgrade record locks which may have been acquired during the transaction
-         RecordLockContext lockCtx = persistenceCtx.getRecordLockContext();
-         Set<Long> released = lockCtx.transactionEnded();
-         
-         // reclaim any primary keys for records deleted and committed or created and rolled back
-         // during the transaction, provided those keys have been fully released (not just
-         // downgraded) by the end of the transaction; note that this may "leak" reclaiming some
-         // primary keys downgraded and still held as share locks by open buffers, for buffers
-         // whose scope extends beyond the end of the transaction
-         reclaimPendingKeys(persistenceCtx.getPersistence(), released);
-         
-         // Allow the connection manager to perform its end of transaction cleanup.  This must
-         // occur after all transaction processing, because it may result in tearing down the
-         // database's session factory.
-         connMgr.transactionEnded(database);
-      }
+   public boolean isImportantBlockTransition()
+   {
+      return txWrapperHelper.isImportantBlockTransition();
    }
    
    /**
@@ -3660,12 +2794,6 @@
        */
       private final Map<Object, Map<String, RecordBuffer>> byLegacyName = new IdentityHashMap<>();
       
-      /**
-       * All buffers into which a new record was loaded (or the old record was reloaded), for a
-       * persistent procedure.
-       */
-      private final Map<RecordBuffer, Boolean> loadedBuffers = new HashMap<>();
-      
       /** Open record buffers for a persistent procedure. */
       private final List<RecordBuffer> openBuffers = new LinkedList<>();
       

=== modified file 'src/com/goldencode/p2j/persist/ChangeBroker.java'
--- old/src/com/goldencode/p2j/persist/ChangeBroker.java	2022-03-25 19:17:12 +0000
+++ new/src/com/goldencode/p2j/persist/ChangeBroker.java	2022-09-06 18:22:04 +0000
@@ -98,6 +98,17 @@
 **                           Use an identity HashSet where possible.
 **     CA  20220309          Added isQueried(), which checks if a temp-table has any listeners registered for
 **                           events which are a P2JQuery.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
+**     CA  20220906          Extracted all BufferManager state which requires notification for 
+**                           'isImportantBlock' to an external TxWrapper class (including the private class 
+**                           here), to allow the scopeable BufferManager state related only to buffers (and  
+**                           not transaction related) to be registered for scope notifications in a lazy 
+**                           manner, when buffers are accessed/used/opened.
 */
 
 /*
@@ -253,19 +264,6 @@
    }
    
    /**
-    * Register with the {@link com.goldencode.p2j.util.TransactionManager
-    * TransactionManager} a factory object which creates instances of this
-    * class, so that they can be registered to receive notifications of
-    * runtime scope start and finish events.
-    * <p>
-    * This method should be invoked once during the server bootstrap phase.
-    */
-   static void initialize()
-   {
-      TransactionManager.registerScopeableFactory(ChangeBroker::get);
-   }
-   
-   /**
     * Add a scope to the listeners dictionary whenever a new runtime scope
     * opens.
     */
@@ -332,6 +330,17 @@
    }
    
    /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#CHANGE_BROKER}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.CHANGE_BROKER;
+   }
+   
+   /**
     * Register a listener to receive DMO property change notifications.  The
     * listener will receive notifications of any changes to DMOs of the types
     * for which it is registered, as they occur in this scope or in scopes
@@ -347,6 +356,8 @@
     */
    void addListener(RecordChangeListener listener)
    {
+      BufferManager.registerScopeable(null);
+      
       addListener(listener, listeners.size());
    }
    
@@ -383,6 +394,8 @@
     */
    void addListener(RecordChangeListener listener, int depth)
    {
+      BufferManager.registerScopeable(null);
+      
       boolean global = (depth == 0);
       
       Iterator<RecordBuffer> iter = listener.recordBuffers();

